#ifndef __MD_MESH__
#define __MD_MESH__

#include <Particle.h>
#include <Vector.h>
#include <Array.h>

namespace ZSET{
  using namespace ZSET;

class MD_ELEMENT
{
protected:
  int id;
  LIST<int> particles, color;
  LIST<VECTOR> coord_0;
  ARRAY<VECTOR> coord;
public:
  MD_ELEMENT() {}
  MD_ELEMENT(int i) { id = i;}
  MD_ELEMENT(LIST<int> p) { particles = p;}
 ~MD_ELEMENT() {}  

  VECTOR strain, F;

  void add_particle(int p, VECTOR r, int c) { particles.add(p); coord_0.add(r); color.add(c); }
  void set_coord(int i, VECTOR r) { coord[i] = r; }
  void done() { coord.resize(particles.size()); }

  int size() { return particles.size(); }
  int get_color(int i) { return color[i]; }
  int  get_particle(int i) { return particles[i]; }
  VECTOR get_coord(int i) { return coord[i]; }
  VECTOR get_coord0(int i) { return coord_0[i]; }
};
 
class MD_MESH
{
protected:
  LIST<MD_ELEMENT*> elements;
public:
  MD_MESH() {}
  MD_MESH(STRING n) { name = n; elements.resize(0); }
 ~MD_MESH() {}

  STRING name;

  void add_element(MD_ELEMENT* el) { elements.add(el); }
  MD_ELEMENT*& get_element(int i) { if (i >= 0 && i <elements.size() ) return elements[i]; else INTERNAL_ERROR; return elements[0]; }
  int size() { return elements.size(); }
//  ELEMENT* get_element(int i) { return elements[i]; }
  void done() { for (int i = 0; i<size(); i++) elements[i]->done(); }
};

}

#endif

