#include <Particle.h>

using namespace ZSET;

PARTICLE::PARTICLE(int i, VECTOR xi)
{
  id = i;
  x = xi;
  v = 0*xi;
  F = 0*xi; 
  F_old = 0*xi; 
  bc_x.resize(0);
  bc_v.resize(0);
  bc_f.resize(0);
}
PARTICLE::PARTICLE(int i, double mi, VECTOR xi, VECTOR vi) 
{
  if (xi.size() != vi.size())
    ERROR("Not compatible POSITION and VELOCITY");
  id = i; 
  x  = xi;
  v  = vi; 
  F = 0*xi; 
  F_old = 0*xi; 
  bc_x.resize(0);
  bc_v.resize(0);
  bc_f.resize(0);
}

PARTICLE::PARTICLE(int i, int col, VECTOR xi, VECTOR vi, MD_MATERIAL* m)
{
  if (xi.size() != vi.size())
    ERROR("Not compatible POSITION and VELOCITY");
  id = i;
  color = col;
  x  = xi;
  v  = vi; 
  F = 0*xi; 
  F_old = 0*xi;
  mat = m; 
  bc_x.resize(0);
  bc_v.resize(0);
  bc_f.resize(0);
}

double PARTICLE::get_kinetic_energy()
{
  return 0.5*mat->mass*(v|v);
}


