#!/usr/bin/env python

import sys
import random
import numpy as np

print ""

if len(sys.argv)!=3:
  print("Error: I need 2 arguments: [1] number of particles, [2] seed for the generator of random numbers.\nQuiting...\n")
  exit(1)

N = int(sys.argv[1])
seed = int(sys.argv[2])
random.seed(seed)

box = 1.

particles = np.zeros((N,2))

file_name = "initial_config.data"
output_file = file(file_name,"w")
output_file.write("***particles\n 2 " + str(N)+"\n")

ip = 0
for i in range(1,N+1):
  x = random.random()*box
  y = random.random()*box
  vx = 0
  vy = 0
  particles[i-1][0] = x
  particles[i-1][1] = y
  output_file.write(str(i)+" "+str(particles[i-1][0])+" "+str(particles[i-1][1])+" "+str(vx)+" "+str(vy)+" 1\n")

print("I have generated "+str(N)+" particles and saved them in file: \""+file_name+"\"\n")
output_file.close()

